/**
  ******************************************************************************
  * @file           : event_handler.c
  * @brief          : Handle the event generated by the thread
  *                   
  * @author         : Baptiste Solioz
  * @date           : 16. October 2020
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "event_handler.h"

/* Private constants ---------------------------------------------------------*/
#define     EVENT_HANDLER_MAX_SUB   20

/* Private typedef -----------------------------------------------------------*/
const osMutexAttr_t Thread_Mutex_attr = {
  "EventHandlerMutex",                          // human readable mutex name
  osMutexRecursive | osMutexPrioInherit,    // attr_bits
  NULL,                                     // memory for control block   
  0U                                        // size for control block
};
 

/* Private typedef -----------------------------------------------------------*/
typedef struct {
    EventType_t         type;
    osMessageQueueId_t  queue;
} Event_Subscribe_t;
typedef struct {
    Event_Subscribe_t   subList[EVENT_HANDLER_MAX_SUB];
    uint8_t             subIndex;
} Event_Handler_Attr_t;

/* Private variables ---------------------------------------------------------*/
Event_Handler_Attr_t    event_handler_data;
osMutexId_t             handler_mutex; 
osMutexId_t             sub_mutex; 


/********************************************************************************
  * @brief Event Handler Initialize
  * @param None
  * @retval None
********************************************************************************/
void event_handler_init()
{
    // Create mutex for the handler
    handler_mutex = osMutexNew(&Thread_Mutex_attr);
    if (handler_mutex == NULL)  
    {
        EVENT_TLOG(LOGE, "Mutex not created");
    }
    // Create mutex for the subscription
    sub_mutex = osMutexNew(&Thread_Mutex_attr);
    if (sub_mutex == NULL)  
    {
        EVENT_TLOG(LOGE, "Mutex not created");
    }

    event_handler_data.subIndex = 0;

    EVENT_TLOG(LOGI, "Initialization Done");
}

/********************************************************************************
  * @brief Event Transmit
  * @param message : Event to send
  * @retval Success
********************************************************************************/
int8_t event_handler_send(EventMessage_t* message)
{
    osStatus_t  status;
    int8_t      retVal = -1;
    if(handler_mutex != NULL)
    {
        if(!IS_IRQ())
        {
            // Event send from Thread -> mutex
            status = osMutexAcquire(handler_mutex,1000);
            if(status == osOK)
            {
                for(uint8_t i=0; i<EVENT_HANDLER_MAX_SUB; i++)
                {
                    if(event_handler_data.subList[i].type == message->type)
                    {
                        //EVENT_TLOG(LOGI, "Put new message in Queue %d %d", event_handler_data.subList[i].queue, message->type);
                        // Put message in queue -> don't wait if full
                        status = osMessageQueuePut(event_handler_data.subList[i].queue, message, 0U, 0U);
                        if(status == osOK)
                        {
                            retVal = 0;
                        }
                        else
                        {
                            EVENT_TLOG(LOGE, "Message queue error %d, nb queue mess %d\n\r", status, osMessageQueueGetCount(event_handler_data.subList[i].queue));
                        }
                    }
                }
                
                status = osMutexRelease	(handler_mutex);
            }
            else
            {
                EVENT_TLOG(LOGE, "Mutex Acquire Failure code %d\n\r", status);
            }
        }
        else
        {
            // Event send from IRQ
            for(uint8_t i=0; i<EVENT_HANDLER_MAX_SUB; i++)
            {
                if(event_handler_data.subList[i].type == message->type)
                {
                    //EVENT_TLOG(LOGI, "Put new message in Queue %d %d", event_handler_data.subList[i].queue, message->type);
                    status = osMessageQueuePut(event_handler_data.subList[i].queue, message, 0U, 0);
                    if(status == osOK)
                    {
                        retVal = 0;
                    }
                    else
                    {
                        EVENT_TLOG(LOGE, "Message queue error %d\n\r",status);
                    }
                }
            }
        }
    }
    return retVal;
}

/********************************************************************************
  * @brief Event Thread submission
  * @param eventType : Type of event subscribed
  * @param queue : Queueu Id of the subscription
  * @retval Success
********************************************************************************/
int8_t event_handler_subscribe(EventType_t eventType, osMessageQueueId_t queue)
{
    osStatus_t  status;
    int8_t      retVal = -1;
    if(sub_mutex != NULL)
    {
        // From thread -> mutex
        status = osMutexAcquire(sub_mutex,1000);
        if(status == osOK)
        {
            // Add subscribtion in table
            if(event_handler_data.subIndex < EVENT_HANDLER_MAX_SUB)
            {
                EVENT_TLOG(LOGI, "Add Subscribe for event %d queue %d\n\r", eventType, queue);
                event_handler_data.subList[event_handler_data.subIndex].type = eventType;
                event_handler_data.subList[event_handler_data.subIndex].queue = queue;
                event_handler_data.subIndex++;
                retVal = 0;
            }
            else
            {
                EVENT_TLOG(LOGE, "No more subscriber allowed\n\r");
            }

            status = osMutexRelease	(sub_mutex);
        }
        else
        {
            EVENT_TLOG(LOGE, "Mutex Acquire Failure code %d\n\r", status);
        }
    }
    return retVal;
}